/*
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License") you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 * 
 * The Original Code in this file was released April 1, 2001
 * 
 * The Initial Developer of the Original Code is HJ van Rantwijk.
 * all Portions created by HJ van Rantwijk are Copyright (C) 2001-2005 
 * by HJ van Rantwijk. All Rights Reserved.
 * 
 * Contributor(s):
 *   HJ van Rantwijk <bugs4hj@netscape.net> (Original Author)
 * 
 */

var mzPrefInit =
{
  _prefErrors : 0,
  _newPrefsAdded : 0,

  initPreferences: function()
  {
    if (!pref) { // Make sure 'pref' is initialized (this seems to fail in Netscape 7)
      var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
      pref = prefService.getBranch(null);
    }
    if (mzPreferences.readMyPref("multizilla.prefs.checked", "bool", false))
      return; // Bail out if already checked. This should improve our startup time

    // -- prefs.js --------------------------------------------------------------------------------
    mzPreferences.readMyPref("multizilla.bookmark.close-remaining", "bool", false);
    mzPreferences.readMyPref("multizilla.bookmark.folders", "int", 15);
    mzPreferences.readMyPref("multizilla.bookmark.folders.confirmation", "int", 3);
    mzPreferences.readMyPref("multizilla.bookmark.groups", "int", 15);
    mzPreferences.readMyPref("multizilla.bookmark.groups.confirmation", "int", 3);

    mzPreferences.readMyPref("multizilla.bookmark.loadInBackground", "bool", false);
    mzPreferences.readMyPref("multizilla.bookmark.menuitem.allow-middleclick", "bool", true);
    mzPreferences.readMyPref("multizilla.bookmark.menuitem.middleclick-closepopups", "bool", true);

    mzPreferences.readMyPref("multizilla.browsersession.skip.navigator.startup", "bool", true);
    mzPreferences.readMyPref("multizilla.browsersession.skip.confirm-single-window", "bool", false);
    mzPreferences.readMyPref("multizilla.browsersession.skip.save-single-tab", "bool", false);

    mzPreferences.readMyPref("multizilla.browser.docShell.allowPlugins", "bool", true);
    mzPreferences.readMyPref("multizilla.browser.docShell.allowJavascript", "bool", true);
    mzPreferences.readMyPref("multizilla.browser.docShell.allowMetaRedirects", "bool", true);
    mzPreferences.readMyPref("multizilla.browser.docShell.allowSubframes", "bool", true);
    mzPreferences.readMyPref("multizilla.browser.docShell.allowImages", "bool", true);
    mzPreferences.readMyPref("multizilla.check.webtools", "bool", true);  
    mzPreferences.readMyPref("multizilla.confirm.reopen-tabs", "bool", true);
    mzPreferences.readMyPref("multizilla.confirm.quit", "int", 11);
    mzPreferences.readMyPref("multizilla.confirm.quit-session", "bool", false);

    // Preferences for MultiZilla's Content Blocker that can be set in the Permission Manager 
    mzPreferences.readMyPref("multizilla.content-blocker.enabled", "bool", false);

    mzPreferences.readMyPref("multizilla.content-blocker.behavior.image", "int", 0); // 0 = disabled / 1 = Accept image / 2 = Accept image / 4 = Block image 8 = Ask me before accepting image
    mzPreferences.readMyPref("multizilla.content-blocker.behavior.object", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.behavior.script", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.behavior.frame", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.behavior.document", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.behavior.meta", "int", 0);

    mzPreferences.readMyPref("multizilla.content-blocker.sound_enabled.image", "int", 0); // 0 = don't play sound 1 = play sound for the first blocked image only 2 = play sound for all blocked images
    mzPreferences.readMyPref("multizilla.content-blocker.sound_enabled.object", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.sound_enabled.script", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.sound_enabled.frame", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.sound_enabled.document", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.sound_enabled.meta", "int", 0);

    mzPreferences.readMyPref("multizilla.content-blocker.sound_url.image", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.sound_url.object", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.sound_url.script", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.sound_url.frame", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.sound_url.document", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.sound_url.meta", "string", "");

    mzPreferences.readMyPref("multizilla.content-blocker.log_enabled.image", "int", 1); // 0 = logging disabled / 1 = log '/multizilla.mozdev.' / 2 = log 'http://multizilla.mozdev.org/graphics/hj.gif'
    mzPreferences.readMyPref("multizilla.content-blocker.log_enabled.object", "int", 1);
    mzPreferences.readMyPref("multizilla.content-blocker.log_enabled.script", "int", 1);
    mzPreferences.readMyPref("multizilla.content-blocker.log_enabled.frame", "int", 1);
    mzPreferences.readMyPref("multizilla.content-blocker.log_enabled.document", "int", 1);
    mzPreferences.readMyPref("multizilla.content-blocker.log_enabled.meta", "int", 1);
    mzPreferences.readMyPref("multizilla.content-blocker.java-enabled", "bool", pref.getBoolPref("security.enable_java"));

    mzPreferences.readMyPref("multizilla.content-blocker.trim-behavior.image", "int", 7); // 1 = trim third level domain (www) from url / 2 = trim top level domain (see code snip) / 4 = add leading '/'
    mzPreferences.readMyPref("multizilla.content-blocker.trim-behavior.object", "int", 7);
    mzPreferences.readMyPref("multizilla.content-blocker.trim-behavior.script", "int", 7);
    mzPreferences.readMyPref("multizilla.content-blocker.trim-behavior.frame", "int", 7);
    mzPreferences.readMyPref("multizilla.content-blocker.trim-behavior.document", "int", 7);
    mzPreferences.readMyPref("multizilla.content-blocker.trim-behavior.meta", "int", 7);
  
  /* 
    mzPreferences.readMyPref("multizilla.content-blocker.mimetype.behavior.frame", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.mimetype.behavior.image", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.mimetype.behavior.meta", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.mimetype.behavior.object", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.mimetype.behavior.script", "int", 0);
    mzPreferences.readMyPref("multizilla.content-blocker.mimetype.behavior.document", "int", 0);

    mzPreferences.readMyPref("multizilla.content-blocker.mimetypes.for.frame", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.mimetypes.for.image", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.mimetypes.for.meta", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.mimetypes.for.object", "string", "video/quicktime, application/x-shockwave-flash, application/futuresplash");
    mzPreferences.readMyPref("multizilla.content-blocker.mimetypes.for.script", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.mimetypes.for.document", "string", "");
  */

    mzPreferences.readMyPref("multizilla.content-blocker.pattern.for.image", "string", "");  
    mzPreferences.readMyPref("multizilla.content-blocker.pattern.for.object", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.pattern.for.script", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.pattern.for.frame", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.pattern.for.document", "string", "");
    mzPreferences.readMyPref("multizilla.content-blocker.pattern.for.meta", "string", "");
    // End of Content Blocker Preferences...  

    mzPreferences.readMyPref("multizilla.document.context-menu.behavior", "int", 1);
    mzPreferences.readMyPref("multizilla.dnd.loadInBackground", "bool", false);
    mzPreferences.readMyPref("multizilla.dnd.tabstripdrops.selected", "bool", true);

    mzPreferences.readMyPref("multizilla.forced.autocomplete", "bool", true);
    mzPreferences.readMyPref("multizilla.forced.autocomplete.onsubmit-remove", "bool", false);

    mzPreferences.readMyPref("multizilla.fullscreen.enabled", "bool", true);
    mzPreferences.readMyPref("multizilla.fullscreen.enable.menubar", "bool", false);
    mzPreferences.readMyPref("multizilla.fullscreen.enable.personaltoolbar", "bool", false);
    mzPreferences.readMyPref("multizilla.fullscreen.enable.status-bar", "bool", true);
    // mzPreferences.readMyPref("multizilla.fullscreen.enable.[toolbar id]", "bool", [true/false]);
    mzPreferences.readMyPref("multizilla.fullscreen.first-browserwindow-only", "bool", true);
    mzPreferences.readMyPref("multizilla.fullscreen.disable.chromeless", "bool", true);
    mzPreferences.readMyPref("multizilla.fullscreen.enable.linktoolbar", "bool", false);
    mzPreferences.readMyPref("multizilla.fullscreen.re-enable-chrome", "bool", true);

    mzPreferences.readMyPref("multizilla.blocked-popup.show-info-message", "bool", true);
    mzPreferences.readMyPref("multizilla.blocked-xpinstall.sound_enabled", "bool", true);
    mzPreferences.readMyPref("multizilla.blocked-xpinstall.sound_url", "string", "");

    mzPreferences.readMyPref("multizilla.info-messages.show-close-botton", "bool", true);
    mzPreferences.readMyPref("multizilla.info-messages.middle-click-close", "bool", false);

    mzPreferences.readMyPref("multizilla.integrated.toolbar", "bool", false);
    mzPreferences.readMyPref("multizilla.integrated.toolbar-notify", "bool", true);
    mzPreferences.readMyPref("multizilla.integrated.toolbar.hide-all-other-buttons", "bool", true);

    mzPreferences.readMyPref("multizilla.mac-ctrl-left-right.behavior", "bool", false);
    mzPreferences.readMyPref("multizilla.managers.use-stacked-windows", "bool", /Win/.test(navigator.platform));
    mzPreferences.readMyPref("multizilla.mouse-middle-click.close", "bool", true);

    mzPreferences.readMyPref("multizilla.mouse-double-click.close", "bool", true);
    mzPreferences.readMyPref("multizilla.tab-manager.confirm.close-items", "bool", true);
    mzPreferences.readMyPref("multizilla.tabstrip.middle-click-action", "int", 0);

    mzPreferences.readMyPref("multizilla.newtabfor.bookmarks", "bool", false);
    mzPreferences.readMyPref("multizilla.newtabfor.ctrl-n", "bool", false);
    mzPreferences.readMyPref("multizilla.newtabfor.groupfolders", "int", 0);
    mzPreferences.readMyPref("multizilla.newtabfor.external-links", "bool", true);
    mzPreferences.readMyPref("multizilla.newtabfor.locationbar", "bool", false);
    mzPreferences.readMyPref("multizilla.newtabfor.mailnews", "bool", false);
    mzPreferences.readMyPref("multizilla.newtabfor.native-applications", "bool", true);
    mzPreferences.readMyPref("multizilla.newtabfor.personal-toolbar", "bool", false);
    mzPreferences.readMyPref("multizilla.newtabfor.sidebar", "bool", false);
    mzPreferences.readMyPref("multizilla.newtabfor.view-source", "bool", true);
    mzPreferences.readMyPref("multizilla.newtabfor.websearch", "bool", true);
    mzPreferences.readMyPref("multizilla.newtabfor.windowopen", "bool", true);

    mzPreferences.readMyPref("multizilla.preferred.fornewtabs", "bool", false);
    mzPreferences.readMyPref("multizilla.preferred.location", "string", "http://multizilla.mozdev.org/index.html");
    mzPreferences.readMyPref("multizilla.preferred.type", "int", 0);
    mzPreferences.readMyPref("multizilla.prefs.use-preference-manager", "bool", false);
    mzPreferences.readMyPref("multizilla.perm-manager.default-manager", "string", "cookieManager");
    mzPreferences.readMyPref("multizilla.perm-manager.confirm.quit", "int", 7);

    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.diskcache", "bool", false);
    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.locationbar", "bool", false);
    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.history", "bool", false);
    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.cookies", "bool", false);
    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.downloads", "bool", false);
    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.formdata", "bool", false);
    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.passwords", "bool", false);
    mzPreferences.readMyPref("multizilla.privacy.clear-on-exit.confirm", "bool", false);

    mzPreferences.readMyPref("multizilla.prevent.double", "bool", true);
    mzPreferences.readMyPref("multizilla.refspoof.spoofing", "int", 1);
    mzPreferences.readMyPref("multizilla.refspoof.spoofurl", "url", "http://ref.spoof.org/refspoof.cgi");
    mzPreferences.readMyPref("multizilla.remove.form-target", "bool", false);
    mzPreferences.readMyPref("multizilla.reopen-tabmenu.display-icons", "int", 2);
    mzPreferences.readMyPref("multizilla.reopen-tabmenu.display-maxitems", "int", 15);

    mzPreferences.readMyPref("multizilla.showbutton.privacymanager", "bool", true);
    // Buttons on the navigation toolbar
    mzPreferences.readMyPref("multizilla.showbutton.qpmenu", "bool", false);
    mzPreferences.readMyPref("multizilla.showbutton.clearlocbar", "bool", false);
    // Buttons on the MultiZilla toolbar
    mzPreferences.readMyPref("multizilla.showbutton.mzmenubutton", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.newtab", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.tabpos", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.tabstrip", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.tabmanager", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.quickprefmenu", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.update", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.jsconsole", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.inspector", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.permmanager", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.sessionmanager", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.closeThis", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.closeOther", "bool", true);
    mzPreferences.readMyPref("multizilla.showbutton.closeAll", "bool", true);

    mzPreferences.readMyPref("multizilla.statusbar.display-blocked-windows-button", "bool", true);
    mzPreferences.readMyPref("multizilla.statusbar.display-allowImages-button", "bool", true);
    mzPreferences.readMyPref("multizilla.statusbar.display-allowJavascript-button", "bool", true);
    mzPreferences.readMyPref("multizilla.statusbar.display-allowMetaRedirects-button", "bool", true);
    mzPreferences.readMyPref("multizilla.statusbar.display-allowPlugins-button", "bool", true)
    mzPreferences.readMyPref("multizilla.statusbar.display-allowSubframes-button", "bool", true);

    mzPreferences.readMyPref("multizilla.tabbar.closebutton", "bool", false);
    mzPreferences.readMyPref("multizilla.tabbar.newbutton", "bool", false);
    mzPreferences.readMyPref("multizilla.tabbar.middle-click-opentab", "int", 0);
    mzPreferences.readMyPref("multizilla.tabbar.double-click-opentab", "bool", true);

    mzPreferences.readMyPref("multizilla.tabs.automatic-selection", "int", 0);
    mzPreferences.readMyPref("multizilla.tabs.blank-tab-first", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.confirm-close", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.confirm-close-other", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.ctrl-click.url-to-clipboard", "bool", false);
    mzPreferences.readMyPref("multizilla.tabs.cropping", "int", 2);
    mzPreferences.readMyPref("multizilla.tabs.display-popup-icon", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.duplicate-permissions", "bool", false);
    mzPreferences.readMyPref("multizilla.tabs.focus-order", "int", 0);
    mzPreferences.readMyPref("multizilla.tabs.groupmark", "string", "");
    mzPreferences.readMyPref("multizilla.tabs.iconclose", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.init-permissions", "bool", false);
    mzPreferences.readMyPref("multizilla.tabs.insertstyle", "int", 1);
    mzPreferences.readMyPref("multizilla.tabs.load-failure.behavior", "int", 2);
    mzPreferences.readMyPref("multizilla.tabs.mintabwidth", "int", 25);
    mzPreferences.readMyPref("multizilla.tabs.meta-refresh", "int", 0);
    mzPreferences.readMyPref("multizilla.tabs.ontop", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.open-order", "int", 0);
    mzPreferences.readMyPref("multizilla.tabs.remove-popup-icon-delay", "int", 0);
    mzPreferences.readMyPref("multizilla.tabs.restore-session.behavior", "int", 3);
    mzPreferences.readMyPref("multizilla.tabs.restore-session.notify", "bool", false);
    mzPreferences.readMyPref("multizilla.tabs.save-session.behavior", "int", 3);
    mzPreferences.readMyPref("multizilla.tabs.status-leds", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.session-property-changes.confirmation", "bool", true);
    mzPreferences.readMyPref("multizilla.tabs.tabwidth", "int", 175);
    mzPreferences.readMyPref("multizilla.tabs.title", "bool", true);

    mzPreferences.readMyPref("multizilla.tabs.label.color", "string", ""); 
    mzPreferences.readMyPref("multizilla.tabs.label.backgroundcolor", "string", ""); 
    mzPreferences.readMyPref("multizilla.tabs.label.selected.color", "string", "");
    mzPreferences.readMyPref("multizilla.tabs.label.selected.backgroundcolor", "string", "");
    mzPreferences.readMyPref("multizilla.tabs.label.selected.usebold", "bool", true);

    mzPreferences.readMyPref("multizilla.uam.show-about-page", "bool", true);
    mzPreferences.readMyPref("multizilla.uam.close-about-page", "bool", true);
    mzPreferences.readMyPref("multizilla.uam.show-help-onstartup", "bool", true);
    mzPreferences.readMyPref("multizilla.uam.prevent-delete-current", "bool", true);
    mzPreferences.readMyPref("multizilla.uam.set-default-useragent-onbrowserexit", "bool", true);
    mzPreferences.readMyPref("multizilla.uam.sync-with-http-useragent", "bool", true);
  
    mzPreferences.readMyPref("multizilla.window-open.redirector", "bool", false);
    mzPreferences.readMyPref("multizilla.window-open.behavior", "int", 2);
    mzPreferences.readMyPref("multizilla.window-open.override-features", "bool", false);
    mzPreferences.readMyPref("multizilla.window-open.features", "int", 2047);
    mzPreferences.readMyPref("multizilla.window-open.display-failures", "bool", false);
    mzPreferences.readMyPref("multizilla.window-open.javascript-in-tab", "bool", false);

    var mPrefChecked = (this._newPrefsAdded == 0);
    mzPreferences.writePref("bool", "multizilla.prefs.checked", mPrefChecked);

    if (this._prefErrors)
      mzQuickPrefsMenu.doAlert(window, "", mzGetTextFromBundle("corruptPref"));
  },

  checkVendorPrefs: function()
  {
    const prefBranch = "general.useragent.";
    var MultiZillaVersion = getBrowser().mVersion+getBrowser().mVersionRev;
    var vendor = mzPreferences.readMyPref(prefBranch + "vendor", "string", "MultiZilla");
    var vendorSub = mzPreferences.readMyPref(prefBranch + "vendorSub", "string", MultiZillaVersion);

    if (vendor != "MultiZilla")
      mzPreferences.writePref("string", prefBranch + "vendor", "MultiZilla");
    if (vendorSub != MultiZillaVersion)
      mzPreferences.writePref("string", prefBranch + "vendorSub", MultiZillaVersion);

    this.checkGeneralUseragentMiscPref();
  },

  checkGeneralUseragentMiscPref: function()
  {
    const prefID = "general.useragent.misc";

    try {
      if (pref.prefHasUserValue(prefID))
        pref.clearUserPref(prefID);
    } catch(ex) {
    }
  }
}

var mzPreferences = 
{

  readMyPref: function(aPrefIdentifier, aPrefType, aDefaultValue)
  {
    var prefValue;

    switch(aPrefType)
    {
      case "bool": 
      {
        try {
          prefValue = pref.getBoolPref(aPrefIdentifier); 
        } catch(ex) {
          this.fixWrongPrefSetting(aPrefType, aPrefIdentifier, aDefaultValue);
          return Boolean(aDefaultValue);
        }
        return Boolean(prefValue);
      }
      case "int":
      {
        try {
          prefValue = pref.getIntPref(aPrefIdentifier);
        } catch(ex) {
          this.fixWrongPrefSetting(aPrefType, aPrefIdentifier, aDefaultValue);
          return aDefaultValue;
        }
        return prefValue;
      }
      case "string":
      {
        try {
          prefValue = pref.getComplexValue(aPrefIdentifier, Components.interfaces.nsISupportsString);
        } catch(ex) {
          this.fixWrongPrefSetting(aPrefType, aPrefIdentifier, aDefaultValue);
          return aDefaultValue;
        }
        return prefValue.data.length ? prefValue.data : aDefaultValue;
      }
      case "char":
      {
        try {
          prefValue = pref.getCharPref(aPrefIdentifier);
        } catch(ex) {
          this.fixWrongPrefSetting(aPrefType, aPrefIdentifier, aDefaultValue);
        }
	    return prefValue ? prefValue : aDefaultValue;
      }
      case "url":
      {
        try {
          prefValue = pref.getComplexValue(aPrefIdentifier, Components.interfaces.nsIPrefLocalizedString);
        } catch(ex) {
          this.fixWrongPrefSetting(aPrefType, aPrefIdentifier, aDefaultValue);
          return (aDefaultValue);
        }
        return prefValue.data.length ? prefValue.data : aDefaultValue;
      }
      default:
      {
        dump('mzPreferences.readMyPref(): Unsupported pref type "'+aPrefType+'" used for: '+aPrefIdentifier);
      }
    }
    return (aDefaultValue);
  },

  fixWrongPrefSetting: function(aPrefType, aPrefIdentifier, aDefaultValue) 
  {
    if (pref.prefHasUserValue(aPrefIdentifier)) {
      pref.clearUserPref(aPrefIdentifier);
      dump("\nError: prefType = "+aPrefType+"\naPrefIdentifier = "+aPrefIdentifier+"\nprefValue = "+aDefaultValue);
      this._prefErrors++;
    }
    this.writePref(aPrefType, aPrefIdentifier, aDefaultValue);
    this._newPrefsAdded++;
  },

  writePref: function(aPrefType, aPrefIdentifier, aPrefValue)
  {
    try {
      switch (aPrefType) {
        case "bool":
        {
          pref.setBoolPref(aPrefIdentifier, aPrefValue);
          break;
        }
        case "int":
        {
          pref.setIntPref(aPrefIdentifier, aPrefValue);
          break;
        }
        case "string":
        {
          var str;
          str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
          str.data = aPrefValue;
          pref.setComplexValue(aPrefIdentifier, Components.interfaces.nsISupportsString, str);
          break;
        }
        case "url":
        {
          pref.setComplexValue(aPrefIdentifier, Components.interfaces.nsIPrefLocalizedString, aPrefValue);
          break;
        }
        case "char":
        {
          pref.setCharPref(aPrefIdentifier, aPrefValue);
          break;
        }
        default:
        {
          dump('writePref(): Unsupported pref type "'+aPrefType+'" used for: '+aPrefIdentifier);
        }
      }
    }
    catch (ex) { // die silently 
    }
  },

  toggleBoolPref: function(aPrefIdentifier, aPrefType, aDefaultValue)
  {
    var prefValue = this.readMyPref(aPrefIdentifier, aPrefType, aDefaultValue);
    this.writePref(aPrefType, aPrefIdentifier, !prefValue);
  }

}

